

camera 
{
location  <0,40,-80>*15/3*1.125
direction 15*z
look_at <0,0,0>  
} 

#declare Start = .5;
#declare End = .65; 
#if (clock > Start)
#if (clock <= End)
#declare keyclock = mod((clock-Start)/(End-Start),1) #else
#declare keyclock = 1 #end #else
#declare keyclock = 0 #end
#declare mclock2 = sin((keyclock-.5)*pi)/2+.5 

#declare GlowTex =
texture {pigment {slope x color_map {[0 rgb <1,.45,0>*1.5 transmit 1*(1-mclock2)][1 rgb <1,.45,0>*.5 transmit 1*(1-mclock2)]}}
finish {ambient 1}}



union { 

#declare Start = .4;
#declare End = .66; 
#declare keyclock = 0  
#if (clock > Start)
#if (clock <= End)
#declare keyclock = mod((clock-Start)/(End-Start),1) 
#else
#declare keyclock = 1
#end
#else
#declare keyclock = 0
#end

#declare mclock = pow(keyclock,.5)
#declare mclock2 = sin((keyclock-.5)*pi)/2+.5  

#declare Start = .6;
#declare End = .75; 
#declare keyclock = 0  
#if (clock > Start)
#if (clock <= End)
#declare keyclock = mod((clock-Start)/(End-Start),1) 
#else
#declare keyclock = 1
#end
#else
#declare keyclock = 0
#end

#declare fclock = sin((keyclock-.5)*pi)/2+.5

box {<-20,0,-20>,<20,0,20> no_shadow hollow 
texture {
pigment {
image_map {
png "radar2.png"  
interpolate 2
}
} 
finish {ambient 2} 
scale <40,40,1> 
rotate 90*x
translate <-20,0,-20>     
}
scale .75 
translate <0,-15*mclock2,0> 
}





#if (clock <End) 
box {<-20,0,-20>,<20,0,20> no_shadow hollow 
texture {
pigment {
image_map {
png "radar2.png"  
interpolate 2
}
} 
finish {ambient 2*(1-fclock)} 
scale <40,40,1> 
rotate 90*x
translate <-20,0,-20>     
} 
scale .75
rotate <90,0,0> 
translate <0,0,15*mclock2>
}

box {<-20,0,-20>,<20,0,20> no_shadow hollow 
texture {
pigment {
image_map {
png "radar2.png"  
interpolate 2
}
} 
finish {ambient 2*(1-fclock)} 
scale <40,40,1> 
rotate 90*x
translate <-20,0,-20>     
}
scale .75 
rotate <0,0,90> 
translate <-15*mclock2,0,0>
}  
#end

rotate 120*clock*y 
}
 
 


#declare Start = .5;
#declare End = 1; 
#declare keyclock = 0  
#if (clock > Start)
#if (clock <= End)
#declare keyclock = mod((clock-Start)/(End-Start),1) 
#else
#declare keyclock = 1
#end
#else
#declare keyclock = 0
#end

#declare mclock = pow(keyclock,.5)
#declare mclock2 = sin((keyclock-.5)*pi)/2+.5


#declare RBox3 = box {0,1}
#declare RBox2 = box {0,1}
#declare RBox = box {0,1}
                          
#if (clock >Start)                          
// Object type: World
// Name: Root
object
{
   union
   {
      // Object type: Polynomial
      // Name: NoName
      object
      {
         RBox2

         scale < 13, 24.5, 20 >
         translate < -6.5, -12, -9 >
      }
      // Object type: Composite
      // Name: group #1
      object
      {
         union
         {
            // Object type: Difference
            // Name: 'and not'
            object
            {
               difference
               {
                  // Object type: Sphere
                  // Name: NoName
                  object
                  {
                     sphere { < 0, 0, 0 >, 1 }

                     scale < 9, 11, 20 >
                     translate < 5.5, 0, 11.5 >
                  }
                  // Object type: Disc
                  // Name: NoName
                  object
                  {
                     disc { < 0, 0, 0 >, < 0, 1, 0 >, 1, 0 }

                     scale < 20, 1, 20 >
                     rotate < -90, 0, 0 >
                     translate < -2, 0, 11.5 >
                  }
               }
            }
            // Object type: Sphere
            // Name: NoName
            object
            {
               sphere { < 0, 0, 0 >, 1 }

               scale < 9, 11, .01 >
               translate < 5.5, -1.6653e-16, 11.5 >
            }
         }
      }
      // Object type: Composite
      // Name: group #1
      object
      {
         union
         {
            // Object type: Difference
            // Name: 'and not'
            object
            {
               difference
               {
                  // Object type: Sphere
                  // Name: NoName
                  object
                  {
                     sphere { < 0, 0, 0 >, 1 }

                     scale < 9, 11, 20 >
                     translate < 5.5, 0, 11.5 >
                  }
                  // Object type: Disc
                  // Name: NoName
                  object
                  {
                     disc { < 0, 0, 0 >, < 0, 1, 0 >, 1, 0 }

                     scale < 20, 1, 20 >
                     rotate < -90, 0, 0 >
                     translate < -2, 0, 11.5 >
                  }
               }
            }
            // Object type: Sphere
            // Name: NoName
            object
            {
               sphere { < 0, 0, 0 >, 1 }

               scale < 9, 11, .5 >
               translate < 5.5, -1.6653e-16, 11.5 >
            }
         }
         scale <-1,1,1>
      }
      // Object type: HeightField
      // Name: COCP3.TGA
      object
      {
         height_field { tga "C:\COCP2.TGA" smooth water_level .01 translate -.05*y }

         scale < 13, 6, 25 >
         rotate < -90, 0, 0 >
         translate < -6.5, -12.25, -9 >  
         
scale <1,-1,1>
  
texture {GlowTex}
}
      // Object type: HeightField
      // Name: NOZZLE~2.TGA
      object
      {
         height_field { tga "C:\NOZZLE~3.TGA" smooth water_level .025 translate -.025*y}

         scale < 15, 18, 22.5 >
         rotate < 90, 0, 0 >
         translate < 0, 11.25, 11.75 > 
         
         texture {GlowTex}
         
      }  
       // Object type: HeightField
      // Name: NOZZLE~2.TGA
      object
      {
         height_field { tga "C:\NOZZLE~3.TGA" smooth water_level .025 translate -.025*y}

         scale < 15, 18, 22.5 >
         rotate < 90, 0, 0 >
         translate < 0, 11.25, 11.75 > 
         
         texture {GlowTex}
       
       scale <-1,1,1>  
      }
            // Object type: Polynomial
      // Name: NoName
      object
      {
         RBox2

         scale < 9, 6.75, 16.25 >
         translate < -4.5, 11-4, -7.5 >
      }
      // Object type: Polynomial
      // Name: NoName
      object
      {
         RBox2

         scale < 9, 6.75, 16.25 >
         translate < -4.5, -13+4, -7 >
      }
      // Object type: Sphere
      // Name: NoName
      object
      {
         sphere { < 0, 0, 0 >, 1 }

         scale < 1, 1, 7.5 >
         translate < 1.5, 13.5, 1 >
      }
      // Object type: Sphere
      // Name: NoName
      object
      {
         sphere { < 0, 0, 0 >, 1 }

         scale < 1, 1, 7.5 >
         translate < -1.5, 13.5, 1 >
      }
      // Object type: Sphere
      // Name: NoName
      object
      {
         sphere { < 0, 0, 0 >, 1 }

         scale < 1, 1, 7.5 >
         translate < 4.5, -12, 1 >
      }
      // Object type: Sphere
      // Name: NoName
      object
      {
         sphere { < 0, 0, 0 >, 1 }

         scale < 1, 1, 7.5 >
         translate < -4.5, -12, 1 >
      }
      // Object type: Difference
      // Name: 'and not'
      object
      {
         difference
         {
            // Object type: Box
            // Name: NoName
            object
            {
               RBox

               scale < 2, 39, 20 >
               translate < -1, 11, -6.5 >
            }
            // Object type: Disc
            // Name: NoName
            object
            {
               disc { < 0, 0, 0 >, < 0, 1, 0 >, 1, 0 }

               scale < 10, 1, 50 >
               rotate < 98.471, 0, 0 >
               translate < 0, 11, -6.5 >
            }
            // Object type: Box
            // Name: NoName
            object
            {
               box { < 0, 0, 0 >, < 1, 1, 1 > }

               scale < 10, 26, 20 >
               rotate < -5.528, 0, 0 >
               translate < -5, 25, 11 >
            }
            // Object type: Box
            // Name: NoName
            object
            {
               box { < 0, 0, 0 >, < 1, 1, 1 > }

               scale < 10, 8.858, 20 >
               rotate < -15.25, 0, 0 >
               translate < -5, 16.5, 13.5 >
            }
            // Object type: Disc
            // Name: NoName
            object
            {
               disc { < 0, 0, 0 >, < 0, 1, 0 >, 1, 0 }

               scale < 20, 1, 20 >
               rotate < -59.245, 0, 0 >
               translate < 0, 15, 12.5 >
            }
            // Object type: Polynomial
            // Name: NoName
            object
            {
               RBox3

               scale < 1, 15.5, 33 >
               translate < -0.5, 17.5, 6 >

               texture
               {
                  GlowTex
                  scale < 1, 15.5, 33 >
                  translate < -0.5, 17.5, 6 >
               }
            }
            // Object type: Polynomial
            // Name: NoName
            object
            {
               RBox3

               scale < 1, 4, 19 >
               translate < -0.5, 12, 8 >

               texture
               {
                  GlowTex
                  scale < 1, 4, 19 >
                  translate < -0.5, 12, 8 >
               }
            }
            // Object type: Polynomial
            // Name: NoName
            object
            {
               RBox3

               scale < 1, 12.5, 33 >
               translate < -0.5, 34, -14.5 >

               texture
               {
                  GlowTex
                  scale < 1, 12.5, 33 >
                  translate < -0.5, 34, -14.5 >
               }
            }
            // Object type: Polynomial
            // Name: NoName
            object
            {
               RBox3

               scale < 1, 18, 19 >
               translate < -0.5, 15, -14.5 >

               texture
               {
                  GlowTex
                  scale < 1, 18, 19 >
                  translate < -0.5, 15, -14.5 >
               }
            }
         }
      }
      // Object type: Difference
      // Name: ThrustPod
      object
      {
         difference
         {
            // Object type: Sphere
            // Name: NoName
            object
            {
               sphere { < 0, 0, 0 >, 1 }

               scale < 4, 2.5, 8.5 >
               translate < 0, 52.5, 4 >
            }
            // Object type: Cylinder
            // Name: NoName
            object
            {
               cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1  }

               scale < 0.5, 9, 0.5 >
               translate < 1.25, 48, 1 >
            }
            // Object type: Cylinder
            // Name: NoName
            object
            {
               cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1  }

               scale < 0.5, 9, 0.5 >
               rotate < 0, 0, -90 >
               translate < -4.5, 52.5, 1 >
            }
            // Object type: Cylinder
            // Name: NoName
            object
            {
               cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1  }

               scale < 0.5, 9, 0.5 >
               rotate < 0, 0, -90 >
               translate < -4.5, 52.5, 3 >
            }
            // Object type: Cylinder
            // Name: NoName
            object
            {
               cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1  }

               scale < 0.5, 9, 0.5 >
               rotate < 0, 0, -90 >
               translate < -4.5, 52.5, 5 >
            }
            // Object type: Cylinder
            // Name: NoName
            object
            {
               cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1  }

               scale < 0.5, 9, 0.5 >
               rotate < 0, 0, -90 >
               translate < -4.5, 52.5, 7 >
            }
            // Object type: Cylinder
            // Name: NoName
            object
            {
               cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1  }

               scale < 0.5, 9, 0.5 >
               rotate < 0, 0, -90 >
               translate < -4.5, 52.5, 9 >
            }
            // Object type: Cylinder
            // Name: NoName
            object
            {
               cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1  }

               scale < 0.5, 9, 0.5 >
               translate < -1.25, 48, 1 >
            }
            // Object type: Cylinder
            // Name: NoName
            object
            {
               cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1  }

               scale < 0.5, 9, 0.5 >
               translate < -1.25, 48, 5 >
            }
            // Object type: Cylinder
            // Name: NoName
            object
            {
               cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1  }

               scale < 0.5, 9, 0.5 >
               translate < -1.25, 48, 9 >
            }
            // Object type: Cylinder
            // Name: NoName
            object
            {
               cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1  }

               scale < 0.5, 9, 0.5 >
               translate < 1.25, 48, 5 >
            }
            // Object type: Cylinder
            // Name: NoName
            object
            {
               cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1  }

               scale < 0.5, 9, 0.5 >
               translate < 1.25, 48, 9 >
            }
         }
      } 
      
      #declare ThrustWing =
      // Object type: Composite
      // Name: group #1
      object
      {
         union
         {
            // Object type: Difference
            // Name: ThrustPod
            object
            {
               difference
               {
                  // Object type: Sphere
                  // Name: NoName
                  object
                  {
                     sphere { < 0, 0, 0 >, 1 }

                     scale < 4, 2.5, 8.5 >
                     rotate < 0, 0, 90 >
                     translate < -29.75, -1.6698e-13, 3 >
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.5, 9, 0.5 >
                     rotate < 0, 0, 90 >
                     translate < -25.25, 1.25, 2.3842e-07 >
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.5, 9, 0.5 >
                     translate < -29.75, -4.5, 2.3842e-07 >
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.5, 9, 0.5 >
                     translate < -29.75, -4.5, 2 >
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.5, 9, 0.5 >
                     translate < -29.75, -4.5, 4 >
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.5, 9, 0.5 >
                     translate < -29.75, -4.5, 6 >
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.5, 9, 0.5 >
                     translate < -29.75, -4.5, 8 >
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.5, 9, 0.5 >
                     rotate < 0, 0, 90 >
                     translate < -25.25, -1.25, 2.3842e-07 >
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.5, 9, 0.5 >
                     rotate < 0, 0, 90 >
                     translate < -25.25, -1.25, 4 >
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.5, 9, 0.5 >
                     rotate < 0, 0, 90 >
                     translate < -25.25, -1.25, 8 >
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.5, 9, 0.5 >
                     rotate < 0, 0, 90 >
                     translate < -25.25, 1.25, 4 >
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.5, 9, 0.5 >
                     rotate < 0, 0, 90 >
                     translate < -25.25, 1.25, 8 >
                  }
               }
            }
            // Object type: Difference
            // Name: 'and not'
            object
            {
               difference
               {
                  // Object type: Box
                  // Name: NoName
                  object
                  {
                     RBox

                     scale < 2, 28.5, 20 >
                     rotate < 0, 0, 90 >
                     translate <0, -1, -7.5 >
                  }
                  // Object type: Disc
                  // Name: NoName
                  object
                  {
                     disc { < 0, 0, 0 >, < 0, 1, 0 >, 1, 0 }

                     scale < 10, 1, 50 >
                     rotate < 98.471, 0, 90 >
                     translate < 1.7764e-15, 0, -7.5 >
                  }
                  // Object type: Box
                  // Name: NoName
                  object
                  {
                     box { < 0, 0, 0 >, < 1, 1, 1 > }

                     scale < 10, 26, 20 >
                     rotate < -5.528, 0, 90 >
                     translate < -14, -5, 10 >
                  }
                  // Object type: Box
                  // Name: NoName
                  object
                  {
                     box { < 0, 0, 0 >, < 1, 1, 1 > }

                     scale < 10, 8.858, 20 >
                     rotate < -15.25, 0, 90 >
                     translate < -5.5, -5, 12.5 >
                  }
                  // Object type: Disc
                  // Name: NoName
                  object
                  {
                     disc { < 0, 0, 0 >, < 0, 1, 0 >, 1, 0 }

                     scale < 20, 1, 20 >
                     rotate < -59.245, 0, 90 >
                     translate < -4, -1.7485e-07, 11.5 >
                  }
                  // Object type: Polynomial
                  // Name: NoName
                  object
                  {
                     RBox3

                     scale < 1, 15.5, 33 >
                     rotate < 0, 0, 90 >
                     translate < -6.5, -0.5, 5 >

                     texture
                     {
                        GlowTex
                        scale < 1, 15.5, 33 >
                        rotate < 0, 0, 90 >
                        translate < -6.5, -0.5, 5 >
                     }
                  }
                  // Object type: Polynomial
                  // Name: NoName
                  object
                  {
                     RBox3

                     scale < 1, 4, 19 >
                     rotate < 0, 0, 90 >
                     translate < -1, -0.5, 7 >

                     texture
                     {
                        GlowTex
                        scale < 1, 4, 19 >
                        rotate < 0, 0, 90 >
                        translate < -1, -0.5, 7 >
                     }
                  }
                  // Object type: Polynomial
                  // Name: NoName
                  object
                  {
                     RBox3

                     scale < 1, 3.5, 33 >
                     rotate < 0, 0, 90 >
                     translate < -23, -0.5, -15.5 >

                     texture
                     {
                        GlowTex
                        scale < 1, 3.5, 33 >
                        rotate < 0, 0, 90 >
                        translate < -23, -0.5, -15.5 >
                     }
                  }
                  // Object type: Polynomial
                  // Name: NoName
                  object
                  {
                     RBox3

                     scale < 1, 18, 19 >
                     rotate < 0, 0, 90 >
                     translate < -4, -0.5, -15.5 >

                     texture
                     {
                        GlowTex
                        scale < 1, 18, 19 >
                        rotate < 0, 0, 90 >
                        translate < -4, -0.5, -15.5 >
                     }
                  }
               }
            }
         }
      }
      
 union {ThrustWing rotate 30*z translate <-3.5,-11,1> texture {GlowTex}} 
 union {ThrustWing rotate 30*z translate <-3.5,-11,1> scale <-1,1,1> texture {GlowTex}}    

             
}
texture {GlowTex} 
scale 1.25
translate -8*y 
scale .33
translate -4*y
rotate 120*y*mclock2
}
#end  
 



global_settings {
max_trace_level 120
}